var count = 6,       //每次获取的销售机会条数   
    roleIDMin = 0, //获取更多, 最后一条销售机会的ID
    roleIDMax = 0, //获取更新，第一条销售机会的ID
    mySalesList, //销售机会滑动区域
    _pullDown, _pullUp,  //信息滑动提示
    setload = 0,    //数据加载方式
    loadingStep = 0,  //加载状态0默认，1显示加载状态，2执行加载数据，只有当为0时才能再次加载，这是防止过快拉动刷新
    searchStr = ''; //搜索字符

var init = {
	url:'',
	fn:function(){},
    /*
        创建页面
    */
    create: function (createSalesChanceList,url1) {
        init.searchbarEvent();
        _listloading.show();
        init.url=url1;
        init.fn=createSalesChanceList;
        setTimeout(function () {
        	init.fn(init.getSalesChanceList(0, 0, count, custID, searchStr,setload));
            init.setSize();
            init.setMessageWrapper();
            _listloading.hide();
        },100)
    },
    /*
        搜索框事件
    */
    searchbarEvent: function(){
        $('.ui-searchbar').on('input', function () {
            searchStr = $(this).find('input').val();
            init.searchSetChanceList();
        });

        $('.ui-searchbar').on('tap', function () {
            $(this).parent().addClass('focus');
            $(this).children('.ui-searchbar-input').children().focus();
        });
        $('.ui-searchbar-cancel').on('tap', function () {
            $(this).parent().removeClass('focus');
            $(this).prev().children('.ui-searchbar-input').children().val('');
            searchStr = "";
            init.searchSetChanceList();
        });
        $('.ui-searchbar .fa-times').on('tap', function () {
            $(this).prev().children().val('');
        });
    },
    /*
        搜索重置list
    */
    searchSetChanceList: function () {
        _sales.html("");
        _pullUp.text("上拉加载");
        _pullUp.removeClass("isover");
        _pullUp.hide();
        roleIDMin = 0, 
        roleIDMax = 0,
        setload = 0,    
        loadingStep = 0,
        init.fn(init.getSalesChanceList(0, 0, count, custID, searchStr,setload))
        init.setSize();
        init.setMessageWrapper();
    },
    
    /*
        获取销售机会列表信息
        @roleID 销售机会ID
        @state 0加载更多 1刷新
        @count 获取的数据条数
        @custID 客户ID
        @searchStr 搜索的值
    */
    getSalesChanceList: function (roleID, state, count, custID, searchStr,setload) {                
            jsondata = {
                RoleID: roleID,
                State: state,
                Count: count,
                CustID: custID,
                SearchStr: searchStr,
                setload: setload
            }
        var data = GetDataByUrl_Post(init.url, JSON.stringify(jsondata));
        var json = JSON.parse(JSON.stringify(data));

        if (json.list.length > 0) {
            if(setload==1){//上拉
                roleIDMin=json.list[json.list.length - 1].roleID;
            }else{//下拉
                if(setload==0){
                    roleIDMin=json.list[json.list.length - 1].roleID;
                    roleIDMax=json.list[0].roleID;
                }else{
                    roleIDMax=json.list[0].roleID;
                }
                
            }
        }
        return json;
    },
    
    
    
    /*
        创建销售机会详情表单中的单个元素
        @opt 填充对象
        @name 名称
        @value 值
    */
    createFormElement: function (opt, name, value) {
        var _li = $("<li>", { "class": "table-view-call form-contorl" }),
            _div = $("<div>", { "class": "form-group" }),
            _spanName = $("<span>", { "class": "name" }).text(name),
            _spanValue = $("<span>", { "class": "value" }).text(value);
        _li.append(_div.append(_spanName).append(_spanValue)).appendTo(opt);   
    },
    /*
        设置值格式
        @opt 元素
    */
    setValue: function (opt) {
        opt.find("ul li span.value").each(function () {
            if ($(this).parent().height() > 24) {
                $(this).addClass("val");
            }
        })
    },
    /*
        合并值
        @json 列表数据
        @name 属性
    */
    combinedValue: function (json,name) {
        var str = "";
        if (json.length > 0) {
            for (var i = 0; i < json.length; i++) {
                var g = ",";
                if (i == 0) g = "";
                str += g + json[i][name];
            }
        }

        return str;
    },
    /*
        设置相关元素大小
    */
    setSize: function () {
        var top = $(".ui-search-wrap").height();
        _salesList.height($(window).height() - top).css("top", top);
    },
    /*
        设置滑动区域
    */
    setMessageWrapper: function () {

        _pullDown = $("#pullDown");
        _pullUp = $("#pullUp");

        if (typeof (mySalesList) != "undefined") {
            mySalesList.destroy();
            mySalesList = null;
        }

        mySalesList = new IScroll(_salesList[0], {
            scrollY: true,
            probeType: 2,
            scrollbars: true,//有滚动条  
            mouseWheel: true,//允许滑轮滚动  
            fadeScrollbars: true,//滚动时显示滚动条，默认影藏，并且是淡出淡入效果  
            bounce: true,//边界反弹  
            interactiveScrollbars: true,//滚动条可以拖动  
            shrinkScrollbars: 'scale',// 当滚动边界之外的滚动条是由少量的收缩。'clip' or 'scale'.  
            momentum: true,// 允许有惯性滑动 
            //snap: true,
            //snapSpeed: 400,
            //keyBindings: true
        });
        mySalesList.on("scrollEnd", function () {
            if (loadingStep == 1) {
                if (_pullUp.attr('class').match('pullOn|loading-up')) {
                    _pullUp.removeClass('pullOn').addClass('loading-up');
                    _pullUp.text('加载中...');
                    loadingStep = 2;
                    init.pullUp();
                } else if (_pullDown.attr('class').match('pullOn|loading-down')) {
                    _pullDown.removeClass('pullOn').addClass('loading-down');
                    _pullDown.text('加载中...');
                    loadingStep = 2;
                    init.pullDown();
                }
            }
        })
        mySalesList.on("scroll", function () {
            if (loadingStep == 0 && !_pullDown.attr("class").match("pullOn|loading-down") && !_pullUp.attr("class").match('pullOn|loading-up')) {
                if (this.y > 30) {
                    //下拉刷新效果  
                    _pullDown.attr("class", "pullDown")
                    _pullDown.show();
                    this.refresh();
                    _pullDown.addClass("pullOn");
                    _pullDown.text("松手开始刷新");
                    loadingStep = 1;
                } else if (this.y < (this.maxScrollY - 30) && _sales.height() > _salesList.height() && !_pullUp.attr("class").match("isover")) {
                    //上拉加载效果  
                    _pullUp.attr("class", "pullUp")
                    _pullUp.show();
                    this.refresh();
                    _pullUp.addClass("pullOn");
                    _pullUp.html("松手开始加载");
                    loadingStep = 1;
                }
            }
        });
    },
    /*
    * 上拉加载更多
    */
    pullUp: function () {
        setTimeout(function () {
            setload = 1;
            console.log(roleIDMin);
            console.log(custID);
            var json = init.getSalesChanceList(roleIDMin, 0, count, custID, searchStr,setload);
            console.log(json);
            init.fn(json);
            if (json.list.length == 0) {
                _pullUp.text("没有更多数据了！");
                _pullUp.addClass("isover")
                setTimeout(function () {
                    init.pullUpReset();
                }, 600);
            } else {
                init.pullUpReset();
            }
            loadingStep = 0;
        }, 200);
    },
    /*
    * 下拉刷新
    */
    pullDown: function () {
        setTimeout(function () {
            setload = -1;
            var json = init.getSalesChanceList(roleIDMax, 1, count, custID, searchStr,setload)
            init.fn(json);
            if (json.list.length == 0) {
                _pullDown.text("没有最新的数据了！");
                setTimeout(function () {
                    init.pullDownReset();
                }, 600);
            } else {
                init.pullDownReset();
            }
            loadingStep = 0;
        }, 200);
    },
    /*
    * 下拉刷新重置
    */
    pullDownReset: function () {
        _pullDown.removeClass("loading-down");
        _pullDown.text("下拉刷新");
        _pullDown.attr("class", "pullDown").hide();
        mySalesList.refresh();
    },
    /*
    * 上拉加载重置
    */
    pullUpReset: function () {
        _pullUp.removeClass("loading-up");
        if (!_pullUp.attr("class").match("isover")) {
            _pullUp.text("上拉加载");
            _pullUp.hide();
        }
        mySalesList.refresh();
    }
}