define(["vue","swiper","app/doorIndex/newDoorIndexCtrl","app/doorIndex/url.config","app/doorIndex/tools"],function(Vue,Swiper,newDoorIndexCtrl,urlConfig,tools) {
	var createIndex = {
		//swiper用来设置滚动的插件
		myTabSwiper:null,//门户
		myImgSwiper:null,//轮播
		myNewsSwiper:null,//栏目
		page:null,//页面
		dataList:null,//包含门户和栏目数据
		dataParts:[],//栏目块,最终数据格式是[[门户与栏目数据],[]]
		indexTab:0,//门户下标
		flag:false,
		messageID:0,
		groupDataParts:[],//栏目组合
		/*页面初始化数据*/ 
		doorIndexList:function(){
			//获取门户和栏目信息
			this.dataList = newDoorIndexCtrl.getDoorIndexList(urlConfig.doorIndexListUrl);
			//this.page代表vue处理的数据，将取到的值传给vue处理
			this.page.indexTabsData = this.dataList.protalInfo;
			//判断seestion是否存在，没有就存储一下
			this.makeData(0);
			//处理滚动
			this.initSwiper();
			//组合栏目
			this.groupData(0);
		},
		/*数据整合，将门户信息与栏目信息整合到一起*/ 
		makeData:function(index){
			//获取本地存储数据
			if(this.dataList.protalInfo.length==0){
				$('.ui-notice').removeClass('hide');
			}else{
				$('.ui-notice').addClass('hide');
			}			
			var storages = {
					"indexTabsData":JSON.stringify([this.dataList.protalInfo[0].modules]),
					"tabIndex":0
				};
			//获取门户下标
			this.indexTab = parseInt(index);
			//解析存储数据格式
			var indexTabsDataStorage = JSON.parse(storages.indexTabsData);
			//判断存储中下标下是否存在数据，没有就重新赋值一下
			if(!indexTabsDataStorage[this.indexTab]){
				indexTabsDataStorage[this.indexTab] = this.dataList.protalInfo[this.indexTab].modules;

			}
			
			// 判断存储中是否包含信息
			if(!(indexTabsDataStorage && indexTabsDataStorage[this.indexTab] && newDoorIndexCtrl.isHasMessage(indexTabsDataStorage[this.indexTab]))){
				//栏目信息，包括id等
				var modules = indexTabsDataStorage[this.indexTab];
				//console.log(modules)
				//发送请求栏目信息内容
				var modulesMessages = newDoorIndexCtrl.getDoorModulesMessages(modules,urlConfig.doorModuleUrl);
				//console.log(JSON.stringify(modulesMessages))
				//获取存储数据
				this.dataParts = indexTabsDataStorage;
				//如果下标中没有存在栏目
				if(!this.dataParts[this.indexTab]){
					//添加栏目信息内容
					this.dataParts.push(modulesMessages);
					//改变存储中数据
					indexTabsDataStorage[this.indexTab] = modulesMessages;
					//重新赋值给存储
				}
				//vue处理数据
				this.page.newsParts = [];
				this.page.newsParts = this.dataParts[this.indexTab];
				this.page.groupParts=[];
				//console.log(JSON.stringify(this.dataParts[this.indexTab]))
			}
			else{
				//页面使用存储数据
				this.dataParts = indexTabsDataStorage;
			 	this.page.newsParts = indexTabsDataStorage[this.indexTab];
			 }
				var t3 = setTimeout(function(){
				this.newsTabSwiper().newsTabEvent();
				clearTimeout(t3);
			}.bind(this),100);
		},
		groupData:function(index){//获取组合栏目内容
			var _this=this;
			var arrNum=sessionStorage.getItem('tab2Index');
			if(arrNum!=null){
					//console.log(JSON.stringify(this.dataParts[index]))
				//_this.page.groupParts=[];
				$.each(this.dataParts[index],function(i,v){
					if(v.more==true && v.isLoop==false){
					//_this.page.groupParts=[];						
						//_this.page.groupParts.push(v.messageInfo[arrNum]);
						//console.log(JSON.stringify(v.messageInfo[arrNum]))
						
					}
				})
			}
		},
		/*页面处理可滑动区域*/
		initSwiper:function(){
			/*页面加载数据时会有一定延时，所以延时处理*/
			//处理门户区域可滑动
			var t = setTimeout(function(){
					this.tabSwiper().TabSwiperEvent();
					clearTimeout(t);
				}.bind(this),200);
			 //处理轮播图片
			var t2 = setTimeout(function(){
					if($(".swiper-container-loop-img").length > 0){
						this.imgSwiper();
						clearTimeout(t2);
					}
				}.bind(this),200);
		
			
		},
		/*获取更多栏目信息*/ 
		getMoreMessageData:function(moduleID,channelId,messageID){
			//var messageID="";
			this.flag=true;
			if(this.flag){
				this.messageID=messageID;
			}else{
				this.messageID=0;
			}
			//console.log(this.messageID)
			var moreMessageInfo = newDoorIndexCtrl.getMoreModulesMessages(moduleID,channelId,urlConfig.doorModuleUrl,messageID);
			return moreMessageInfo;
		},
		/*导航*/
		tabSwiper:function(){
			var _self = this;
			this.myTabSwiper = new Swiper('.swiper-container-myTab', {
		        slidesPerView: 'auto',
		        slideToClickedSlide:true,
		        onInit: function(swiper){
			      	//Swiper初始化,获取导航栏下标
				    var storage = newDoorIndexCtrl.getSesstionStorage(["tabIndex"]);
				    var index = 0;
		      		if(storage.tabIndex !=null){
		      			index = storage.tabIndex;
		      		}
		      		/*导航切换下横线*/
				    _self.TabSwiperHrEvent(index);
			    },
		        onSlideChangeEnd: function (swiper) {
		        	//得到当前索引
		        	var clickIndex = _self.myTabSwiper.clickedIndex;
		        	_self.TabSwiperHrEvent(clickIndex);
		        }
		    });
		    //类中可使用链式的方式，this.tabSwiper().TabSwiperEvent();
		    return this;
		},
		/*导航切换事件*/
		TabSwiperEvent:function(){
			var _self = this;
		    $('.swiper-slide-tab').on('click', function (e) {
		        e.preventDefault();
		        //得到当前索引
		        var sildeIndex = _self.myTabSwiper.clickedIndex;
		        _self.TabSwiperHrEvent(sildeIndex);
		    });
		},
		/*导航切换下横线*/
		TabSwiperHrEvent:function(index){
			$(".hr").removeClass("hr_show");
	      	$('.swiper-slide').removeClass("active").eq(index).addClass('active').find(".hr").addClass("hr_show");
	      	newDoorIndexCtrl.setSesstionStorage({"tabIndex":index});
	      	//获取门户下标后，数据整合
	      	this.makeData(index);
		},
		/*栏目组合*/ 
		newsTabSwiper:function(){
			var _self = this;
			this.newsTabEvent();
		    return this;
		},
		/*题目切换事件*/
		newsTabEvent:function(index){
			var _self = this;
		    $('.spaSiwper').on('click', '.newsTabItem',function (e) {
		        e.preventDefault();
		        $(this).addClass('active').siblings().removeClass('active');
		        var _this=$(this);
		        var index=$(this).index();
		        _this.parent().parent().next().find('.spa').eq(index).show().siblings().hide();
		        //得到当前索引
		        var sildeIndex = $(this).index();
		        _self.newsTabEventClr(sildeIndex);
		    });
		    $('.spaSiwper .newsTabItem:nth-child(1)').trigger('click');
		},
		newsTabEventClr:function(index){
			//$('.spaSiwper .newsTabItem').removeClass("active").eq(index).addClass('active');
			newDoorIndexCtrl.setSesstionStorage({"tab2Index":index});
			var tabss=sessionStorage.getItem('tabIndex')
			this.groupData(tabss);
			this.page.groupIndex=index;
		},
		/*图片轮播*/
		imgSwiper:function(){
			var _self = this;
			this.myImgSwiper = new Swiper('.swiper-container-loop-img', {
		        slidesPerView: 1,
		        pagination: '.swiper-pagination',
        		paginationType: 'fraction',
        		observer: true,//修改swiper自己或子元素时，自动初始化swiper
                observeParents: true,//修改swiper的父元素时，自动初始化swiper
		        onInit: function(swiper){
			      //Swiper初始化
			    }
		    });
		    return this;
		},
		/*初始化页面*/ 
		init:function(){
			var _self = this;
			this.page = new Vue({
			  el: '#page',
			  data: {
			  	empty:false,//页面数据是否为空，预留
			    indexTabsData: [],//门户和栏目数据
			    newsParts:[],//栏目信息内容
			    groupParts:[],//组合栏目内容
			    groupIndex:0//组合栏目索引
			  },
  			  watch: {
			    newsParts: {
			      handler: function (val, oldVal) { 
			      	this.newsParts = val;
			      },
			      deep: true
			    },
			    groupIndex:{
			    	 handler: function (val, oldVal) { 
			      	 this.groupIndex = val;
			      },
			      deep: true
			    }
			  },
			  methods:{
			  	/**
					vue中的this和本类无关，this代表vue对象
			  	**/
			  	/*查看更多*/ 
			  	getMoreMessage:function(index,moduleID,channelId,messageID){
			  		//console.log(index)
			  		//请求栏目内容
			  		var message = _self.getMoreMessageData(moduleID,channelId,messageID);
			  		if(typeof index=="number"){//非组合栏目更多
	  			  		if(message.length > 0){
	  			  			if(this.empty){
	  			  				this.empty = false;
	  			  			}
	  			  			//遍历信息
	  			  			$.each(message,function(_index,item){
	  			  				//添加栏目信息
	  				  			_self.dataParts[_self.indexTab][index].messageInfo.push(item);
	  				  			
	  				  		});
	  				  			
	  				  		if(message.length<5){
	  				  			_self.dataParts[_self.indexTab][index].isMore=true;
	  				  		}else{
	  				  			_self.dataParts[_self.indexTab][index].isMore=false;
	  				  		}	  			  			
	  			  			//更新存储内容
	  						//vue数据更新
	  				  		this.newsParts = [];
	  			  			this.newsParts = _self.dataParts[_self.indexTab];
	  			  		}else{
	  			  			this.empty = true;
	  			  		
	  			  			_self.dataParts[_self.indexTab][index].isMore=true;
	  			  			this.newsParts = [];
	  			  			this.newsParts = _self.dataParts[_self.indexTab];
	  			  			
	  			  		}
			  		}else{//组合栏目更多
			  			var groupInx1=index.split(',')[0];
			  			var groupInx2=index.split(',')[1];
	  			  		if(message.length > 0){
	  			  			if(this.empty){
	  			  				this.empty = false;
	  			  			}
	  			  			//遍历信息
	  			  			$.each(message,function(_index,item){
	  			  				//添加栏目信息
	  				  			_self.dataParts[_self.indexTab][groupInx1].messageInfo[groupInx2].push(item);
	  				  		});	  				  		
	  				  			
	  				  		if(message.length<5){
	  				  			_self.dataParts[_self.indexTab][groupInx1].isMore=true;
	  				  		}else{
	  				  			_self.dataParts[_self.indexTab][groupInx1].isMore=false;
	  				  		}	  			  			
	  			  			//更新存储内容
	  						//vue数据更新
	  				  		this.newsParts = [];
	  			  			this.newsParts = _self.dataParts[_self.indexTab];
	  			  		}else{
	  			  			this.empty = true;	  			  		
	  			  			_self.dataParts[_self.indexTab][groupInx1].isMore=true;
	  			  			this.newsParts = [];
	  			  			this.newsParts = _self.dataParts[_self.indexTab];
	  			  			
	  			  		}
		  		
			  		}
			  		
			  		
			  	},
			  	/*查看详细*/
			  	messageDetail:function(messageID){
			  		var url = "messageDetail.html?newpage=1&newWebView=1&hideShare=1&title=新闻详情&messageid="+messageID;
			  		window.location.href = url;
			  	}
			  }
			});

			this.doorIndexList();
		}
	};

    createIndex.init();
});