/**
 *@module OA
 * */
define(['zepto'],function(){

    window.OA = (function (mod, $) {
        mod.getUrlParam =function (name) {
            var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
            var url = decodeURI(window.location.search) //解决中文的问题
            var r = url.substr(1).match(reg);
            if (r != null){
                if(name=='userName'){
                    return decodeURI(decodeURI(r[2]));
                }else{
                    return unescape(r[2]);
                }
            }
            return null;

        };

        mod.setSkin = function () {

            var skinMap = ['#ff6600', '#ab0801', '#38b359', '#3a78b3', '#3c3c3c', '#ab0801'];

            // 0，橙色（默认）
            // 1，红色
            // 2，绿色
            // 3，蓝色
            // 4，灰色
            // 5，白色

            var skinApi = 'https://aip.iuoooo.com/Jinher.AMP.App.SV.StartImgSV.svc/GetAppFaceAndStartImgByAppId',
                appid = OA.getUrlParam("appId"),
                _appId = '{"appId":"' + appid + '"}';

            if (appid) {
                $.ajax({
                    type: 'post',
                    url: skinApi,
                    contentType: "text/json",
                    dataType: 'json',
                    data: _appId || '{"appId":"' + skin_id + '"}',
                    success: function (result) {

                        var skinColor = result.IsSuccess && typeof result.FaceStyle === 'number' ? skinMap[result.FaceStyle] : skinMap[0];
                        appendStyle(skinColor);

                        window.localStorage.setItem('skin_type', result.FaceStyle);

                    },
                    error: function (e) {
                        appendStyle(skinMap[0]);
                        console.log(e);
                    }
                });

            } else {
                var skin_type = parseInt(localStorage.getItem('skin_type'));
                var skinColor = skinMap[skin_type] || skinMap[0] ;
                appendStyle(skinColor);
            }

            function appendStyle(skinColor) {

                var styles = '<style type="text/css">.skin-tab-bar .tab-item.active span,.bar-header-secondary .tab-item.active span{border-bottom:2px solid '+ skinColor +'!important;}.skin-tab-bar .tab-item.active span,.bar-header-secondary .tab-item.active span{color:'+ skinColor +'!important;}.skin-btn-bar .tab-item,.bar-tab .tab-item{background-color:#ffffff!important;}.bar-tab .tab-item.addMoreBtn{color:#898989!important;}.skin-btn-bar .tab-item.active,.bar-tab .tab-item.active,.bar-tab .tab-item.saveDiary,.detail_b span{background-color:'+ skinColor +'!important;}.skin-btn,.btn-primary{background-color:'+ skinColor +'!important;color:#ffffff!important;border:1px solid '+ skinColor +'!important;}.skin-fab,.add-btn,.add-btn-menu{background-color:'+ skinColor +'!important;color:#ffffff!important;border-width:0!important;line-height:1.5rem!important;}.skin-switch.active,.switch.active{background-color:'+ skinColor +'!important;border:1px solid '+ skinColor +'!important;}.skin-upload,.upload{color:'+ skinColor +'!important;}.showA{background-color:transparent!important;font-size:12px!important;}.showA span,.detail-pic-more span{color:'+ skinColor +'!important;}</style>';

                $('head').append(styles);
            }

        };

        mod.hideOnKeyboard = function (el) {

            $('input,textarea').blur(); //避免尺寸计算错误

            window.viewBaseHeight = $(window).height(); //获取视图高度

            $(window).resize(function () {

                //by EddyZhang 减去44px解决某些浏览器浮动地址栏引起的异常

                if ( viewBaseHeight - 44 > $(window).height()) {

                    $(el).addClass('hide');

                } else {

                    $(el).removeClass('hide');

                }

            });

        };

        return mod;

    })(window.OA || {}, window.$);

    OA.setSkin(); //初始化皮肤
    OA.hideOnKeyboard('.J-kb-hide'); //初始化元素键盘响应

});


