define(['mobilekit', 'datetime'], function() {
	//常量
	var Constant = {
		UserListExist: "UserListExist",
		UserIDList: "UserIDList",
		UserNameList: "UserNameList",
		UserPic: "UserPic",
		DeptListExist: "DeptListExist",
		DeptIDList: "DeptIDList",
		DeptNameList: "DeptNameList",
		DeptPic: "DeptPic",
		UserListIDS: "UserListIDS",
		TransactorPre: "WorkFlow_CounterSign_Transactor_"
	}
	//渲染部门或用户html

	function RenderUserHtml(type, userIds, userNames, userPics) {
		var html = '';
		if (userIds && userNames && userPics) {
			var userIdArr = userIds.split(";");
			var userNameArr = userNames.split(";");
			var userPicArr = userPics.split(";");
			for (var i = 0; i < userIdArr.length; i++) {
				html += '<div class="item-person">';
				html += '   <div class="delete">';
				html += '       <img src="' + userPicArr[i] + '" alt="" />';
				html += '       <i class="fa fa-times-circle hide"></i>';
				html += '       <input type="hidden" id="' + userIdArr[i] + '" class="' + type + '" />';
				html += '   </div>';
				html += '   <p class="double-row">' + userNameArr[i] + '</p>';
				html += '</div>';
			}
		}
		return html;
	}
	//渲染办理人

	function RenderTransactor(type) {
		var userIds, userNames, userPics;
		if (type == "user") {
			userIds = sessionStorage.getItem(Constant.TransactorPre + Constant.UserIDList);
			userNames = sessionStorage.getItem(Constant.TransactorPre + Constant.UserNameList);
			userPics = sessionStorage.getItem(Constant.TransactorPre + Constant.UserPic);
		} else {
			userIds = sessionStorage.getItem(Constant.TransactorPre + Constant.DeptIDList);
			userNames = sessionStorage.getItem(Constant.TransactorPre + Constant.DeptNameList);
			userPics = sessionStorage.getItem(Constant.TransactorPre + Constant.DeptPic);
		}
		var html = RenderUserHtml(type, userIds, userNames, userPics);
		$(".transactor-group").prepend(html);
	}
	//清除办理人

	function RemoveTransactor() {
		$(".transactor-group .item-person").has("div.delete").remove();
	}
	//拼接办理人json串

	function GetAcceptUserInfo() {
		var arr = [];
		$(".item-person input:hidden").each(function() {
			arr.push({
				appFieldName: $(this).attr("id"),
				appFieldType: null,
				appFieldValue: "",
				mes: null,
				success: 1
			});
		});
		return arr;
	}
	//获取用户id字符串

	function GetUserIds() {
		var userIds = "";
		$(".item-person input.user:hidden").each(function() {
			userIds += $(this).attr("id") + ";";
		});
		if (userIds.length > 0) userIds = userIds.substr(0, userIds.length - 1);
		return userIds;
	}

	function GetUserIds2() {
		var userIds = "";
		$(".item-person input.user:hidden").each(function() {
			userIds += $(this).attr("id").split(",")[1] + ",";
		});
		if (userIds.length > 0) userIds = userIds.substr(0, userIds.length - 1);
		return userIds;
	}
	//获取部门id字符串

	function GetDeptIds() {
		var userIds = "";
		$(".item-person input.dept:hidden").each(function() {
			userIds += $(this).attr("id") + ";";
		});
		if (userIds.length > 0) userIds = userIds.substr(0, userIds.length - 1);
		return userIds;
	}
	//初始化事件

	function InitEvent() {
		//显示删除人员图标
		$('.item-person').on('longTap', function() {
			$(this).find('.fa-times-circle').removeClass('hide');
		});
		//显示删除人员确认对话窗
		$('.item-person .fa-times-circle').on('click', function() {
			$('.ui-actionsheet-wrap').removeClass('hide');
		});
		//添加办理人
		$('.add-transactor').on('click', function() {
			var uids = GetUserIds();
			var dids = GetDeptIds();
			var ids = uids.split(";").concat(dids.split(";")).join(";");
			sessionStorage.setItem("inputID", Constant.TransactorPre);
			sessionStorage.setItem(Constant.UserListIDS, ids);
			//微信缓存图片语音内容
			if (appType == "weixin") {
				uploadobj.wxcache();
			}
			window.location = 'selectColleague.html';
			return false;
		});
		//头像加载错误则显示默认图片
		$(".item-person img").on("error", function() {
			$(this).attr("src", "../../styles/images/User.png");
		});
		//点击取消按钮
		$("#cancel").on('click', function() {
			history.go(-1);
		});
		//是否显示最多办理人
		$('#switch1').on('click',function(){
			if($(this).hasClass('active')){
				$('#isShow').removeClass('hide');
			}else{
				$('#isShow').addClass('hide');
			}

		})

	}
	//页面加载完毕
	$(function() {
		if (sessionStorage.getItem(Constant.UserListExist) == "1") {
			RenderTransactor("user");
			sessionStorage.removeItem(Constant.UserListExist);
		}
		if (sessionStorage.getItem(Constant.DeptListExist) == "1") {
			RenderTransactor("dept");
			sessionStorage.removeItem(Constant.DeptListExist);
		}

		var strappID = store.get("WF_AppId"),
			strAppTId = store.get("WF_Tem"),
			strButton = '7';
		var strVersion = store.get("WF_Ver"),
			strcondition = store.get("WF_Condition"),
			intNewFlag = store.get("WF_New");
		getStartAppTemInfo(strappID, strAppTId, strVersion, strButton, strcondition, intNewFlag);

		InitEvent();
	});

	//流程提交
	$("#saveAddGoods").on("click", function() {
		//通用业务数据处理
		if (!ExE_Business()) {
			return false;
		}
		var smsTransactFlag = "0";
		var copyFlag = "0";
		var callCheckFlag = $("#chkEndCall").attr("checked") ? 1 : 0;
		var smsFlag = $("#chkEndSms").attr("checked") ? 1 : 0;
		var buttonValue = "";
		var buttonId = "7";

		var appID = store.get("WF_AppId"); //流程Id   
		var appIdea = $("#txtCallText").val(); //store.get("AppIdea") == null ? "" : store.get("AppIdea"); //办理意见
		var appTID = store.get("WF_Tem"); //流程模板ID”,      
		var appTitle = store.get("WF_appTitle"); //流程标题”
		var version = store.get("WF_Ver"); //流程版本”,     		
		var intNextStepId = store.get("NextStep") == null ? "" : store.get("NextStep"); //下一步步骤id
		var appOId = store.get("WF_appOId");
		var appOValue = store.get("WF_appOValue");
		//会签步骤中如果WF_appOValue为空则赋值为0
		if(appOValue=="")
		{
			appOValue = 0;
		}
		var isNewFlag = store.get("WF_New"); // "0";

		var isOrder = $("#chkDoSort").attr("checked") ? "1" : "0"; //会签顺序办理
		var maxCount = $("#txtMaxUserCount").val(); //会签最多办理人
		var isJump = "";
		var promptContent = $("#txtCallText").val(); //结束通知的内容

		var isMulti = "0";
		var transactMode = "0";

		//通知人
		var callUsers = "";
		var callUsers1 = "";
		if (buttonId == "9" && callUsers != '') {
			arrCallUser = callUsers.split(',');
			for (i = 0; i < arrCallUser.length; i++) {
				callUsers1 += '{"appFieldName": "' + arrCallUser[i] + '","appFieldType": null,"appFieldValue": ""},';
			}
			if (callUsers1.length > 0) callUsers1 = callUsers1.substring(0, callUsers1.length - 1);
			callUsers = '"callUsers": {"stepUser": [{"acceptUserInfo":[' + callUsers1 + ']}],"mes":null,"success": 1}';
		} else {
			callUsers = '"callUsers": {"stepUser": [],"mes":null,"success": 1}'
		}
		//通知人结束
		//分发人
		var distributeUsers = "";
		callUsers1 = "";
		if (buttonId == "9" && distributeUsers != '') {
			arrCallUser = distributeUsers.split(',');
			for (i = 0; i < arrCallUser.length; i++) {
				callUsers1 += '{"appFieldName": "' + arrCallUser[i] + '","appFieldType": null,"appFieldValue": "","mes": null,"success": 1},';
			}
			if (callUsers1.length > 0) callUsers1 = callUsers1.substring(0, callUsers1.length - 1);
			distributeUsers = '"distributeUsers": [' + callUsers1 + ']';
		} else {
			distributeUsers = '"distributeUsers":null';
		}
		//分发结束  
		//下一步接收人
		var acceptUserInfo = GetAcceptUserInfo();

		if (acceptUserInfo.length == 0) {
			toast("请选择办理人！");
			return false;
		}
		//下一步接收人结束
		//转下一步步骤列
		var nextStepList = '{"wfNextStepList":[{"acceptUserInfo":' + JSON.stringify(acceptUserInfo) + ',"callFlag":"1","isMulti":null,"nextStepID":"' + intNextStepId + '","nextStepName":null,"smsFlag":"0","transactMode":null,"mes":null,"success":1}],"mes": null,"success": 1}';
		//转下一步步骤列结束
		//新接口调整
		//var strdata = '{"sign":"' + appSign + '","button":{"appFlag":"2","appID":"' + appID + '","appIdea":"' + appIdea + '"';
		var strdata = '{"button":{"appFlag":null,"appID":"' + appID + '","appIdea":"' + appIdea + '"';
		strdata += ',"appTID":"' + appTID + '","appTitle":"' + appTitle + '","businessData":null,"buttonValue":"' + buttonValue + '","buttonId":"' + buttonId + '"';
		strdata += ',"callCheckFlag":"' + callCheckFlag + '","copyFlag":"' + copyFlag + '",' + callUsers + ',' + distributeUsers;
		strdata += ',"isJump":"' + isJump + '","isNewFlag":"' + isNewFlag + '","isOrder":"' + isOrder + '","maxCount":"' + maxCount + '"';
		strdata += ',"nextStepList":' + nextStepList;
		strdata += ',"promptContent":"' + promptContent + '","smsTransactFlag": "' + smsTransactFlag + '","version":"' + version + '","mes": null,"success": 1}';
		strdata += ',"appOId":' + appOId + ',"appOValue":"' + appOValue + '"}';
		//alert(strdata);
		//return ;

		var url= "api/WorkFlow/WorkFlowDeal";
		var param=strdata;
		var data=GetDataByUrl_Post(url,param);
		if (data.success == "1") {
			//window.location.href = "myDoneApproval.html";
			sessionStorage.removeItem(Constant.StepId);
			if (appType == "weixin") {
				//微信保存附件
			    if (data.mes && data.mes.indexOf("|") >= 0) {
			        SaveFileList(data.mes.split("|")[1]);
					//uploadobj.wxuploadImgVoi(data.mes.split("|")[1], "index.html", "workflow");
				}
			    else {
			        SaveFileList(appID);
					//uploadobj.wxuploadImgVoi(appID, "index.html", "workflow");
				}
			} else {
				if (data.mes && data.mes.indexOf("|") >= 0) {
					SaveFileList(data.mes.split("|")[1]);
				} else {
					SaveFileList();
				}
			}
			
			if(appServer == "c6")
			{
				var ajUrl = "api/WorkFlow/SaveDocContent";
				var data = GetDataByUrl_Post(ajUrl, param);
			}

			//发消息
			/*if (callCheckFlag == 1) {
			 SendMessage(GetUserIds2(), "", data.mes);
			 }*/
			if (appType == "weixin") {
			    if (sessionStorage.getItem("ismsg") == "1") {
			        WeixinJSBridge.call("closeWindow");
			    } else {
			        goHome(-3);
			    }

			} else {
				if (store.get("newWebView")=="1") {//如果是1关闭当前WebView
					if(store.get("browser")=="1"){
						goHome(-2);
					} else {
						if (store.get("WF_New") == '1'){
							goHome("", "yes");
						} else {
							goHome("", "");
						}
					}
				} else{
					if (store.get("WF_New") == '1'){
						window.location.href = "myWaitApproval.html";
					} else {
						window.location.href = "index.html";
					}
				}
			}
		} else {
			toast(data.mes);
		}
		/* 旧接口 $.ajax({
		 type: 'post',
		 data: strdata,
		 url: hostUrl + "/api/Form/WorkFlowDeal",
		 async: false,
		 dataType: "json",
		 contentType: "application/json;charset=utf-8",
		 // headers: { "ApplicationContext": BaseHeader },
		 success: function(data) {
		 var json = JSON.stringify(data);
		 //alert(json);
		 if (data.success == "1") {
		 //window.location.href = "myDoneApproval.html";
		 sessionStorage.removeItem(Constant.StepId);
		 if (data.mes && data.mes.indexOf("|") >= 0) {
		 SaveFileList(data.mes.split("|")[1]);
		 } else {
		 SaveFileList();
		 }
		 //发消息
		 if (callCheckFlag == 1) {
		 SendMessage(GetUserIds2(), "", data.mes);
		 }
		 window.location.href = "index.html";
		 } else {
		 toast(data.mes);
		 }
		 }
		 });*/

	});

	//流程转下一步信息
	function getStartAppTemInfo(strappID, strAppTId, strVersion, strButton, strcondition, intNewFlag) {
		//新接口调用
		//var oData = '{"sign":"' + appSign + '","appID":"' + strappID + '","appTID":"' + strAppTId + '","appVersion":"' + strVersion + '","ButtonType":"' + strButton + '","condition":"' + strcondition + '","isNewFlag":"' + intNewFlag + '"}';
		var oData = '{"appID":"' + strappID + '","appTID":"' + strAppTId + '","appVersion":"' + strVersion + '","ButtonType":"' + strButton + '","condition":"' + strcondition + '","isNewFlag":"' + intNewFlag + '"}';
		var url= "api/WorkFlow/GetWFStepInfo";
		var param=oData;
		var data=GetDataByUrl_Post(url,param);
		json = data;
		var curStepId = "";
		//流程可操作按钮
		if (json.wfNextStepList && json.wfNextStepList.length > 0) {
			curStepId = json.wfNextStepList[0].nextStepID;
			$(".nextDep").val(json.wfNextStepList[0].nextStepName);
		}
		//缓存流程数据，弹出页面使用
		store.set("NextJson", json);
		store.set("NextStep", curStepId);
		store.set("NextXH", 0);
		//alert(oData)
		/*旧接口	$.ajax({
		 type: 'post',
		 data: oData,
		 url: hostUrl + "GetWFStepInfo",
		 async: false,
		 dataType: "json",
		 contentType: "application/json;charset=utf-8",
		 // headers: { "ApplicationContext": BaseHeader },
		 success: function(data) {
		 //var json = JSON.stringify(data);
		 //alert(json);
		 //json = JSON.parse(json);
		 json = data;

		 var curStepId = "";
		 //流程可操作按钮
		 if (json.wfNextStepList && json.wfNextStepList.length > 0) {
		 curStepId = json.wfNextStepList[0].nextStepID;
		 $(".nextDep").val(json.wfNextStepList[0].nextStepName);
		 }
		 //缓存流程数据，弹出页面使用
		 store.set("NextJson", json);
		 store.set("NextStep", curStepId);
		 store.set("NextXH", 0);

		 }
		 });*/
	}
	//向手机推送消息

	function SendMessage(toUserIds, toContent, curAppID) {
		var oreturn = "";
		var jsonData = new Object();
		//jsonData.sign = appSign;
		jsonData.strFromUserId = appUserId;
		jsonData.strToUserId = toUserIds;
		if (toContent == "") toContent = "您有流程要办理：" + store.get("WF_appTitle");
		jsonData.strContent = toContent;
		jsonData.strMsgType = "approve"; //信息类型(approve为流程，task为任务，calendar为日程)"

		if (store.get("WF_AppId") == "0" || store.get("WF_AppId") == "") {
			if (curAppID.indexOf("|") >= 0)
				curAppID = curAppID.split("|")[1];
		} else {
			curAppID = store.get("WF_AppId");
		}

		var sOther = curAppID + "," + store.get("WF_appOId") + "," + store.get("WF_Tem") + "," + store.get("WF_appOValue")
		jsonData.strOther = sOther; //业务ID（流程App_ID,AppT_ID,AppO_ID,AppO_Values）"
		//alert(JSON.stringify(jsonData))
		//新接口调用
		var url= "api/Msg/CreateMessInfo";
		var data=GetDataByUrl_Post(url,JSON.stringify(jsonData));
		if (data.success == "1") {
			oreturn = data.mes;
		} else {
			oreturn = "";
		}
		/* 旧接口 $.ajax({
		 type: 'post',
		 data: JSON.stringify(jsonData),
		 url: hostUrl + "CreateMessInfo",
		 async: false,
		 dataType: "json",
		 contentType: "application/json;charset=utf-8",
		 success: function(data) {
		 if (data.success == "1") {
		 oreturn = data.mes;
		 } else {
		 oreturn = "";
		 }
		 }
		 });*/
		return oreturn;
	}
});