define(['mobilekit', 'datetime'], function () {
    //常量
    var Constant = {
        UserListExist: "UserListExist",
        UserIDList: "UserIDList",
        UserNameList: "UserNameList",
        UserPic: "UserPic",
        DeptListExist: "DeptListExist",
        DeptIDList: "DeptIDList",
        DeptNameList: "DeptNameList",
        DeptPic: "DeptPic",
        UserListIDS: "UserListIDS",
        TransactorPre: "WorkFlow_CounterSign_Transactor_"
    }
    //渲染部门或用户html
    function RenderUserHtml(type, userIds, userNames, userPics) {
        var html = '';
        if (userIds && userNames) {
        	if (userIds.indexOf(';')>-1){
        		var userIdArr = userIds.split(";");
                var userNameArr = userNames.split(";");
        	} else {
        		var userIdArr = userIds.split(",");
                var userNameArr = userNames.split(",");
        	}
            for (var i = 0; i < userIdArr.length; i++) {
                html += '<div class="item-person">';
                html += '   <div class="delete">';
                html += "        <img src=\"../../styles/images/User.png\" alt=\"\"/>";
                html += '       <i class="fa fa-times-circle hide"></i>';
                html += '       <input type="hidden" id="' + userIdArr[i] + '" class="' + type + '" />';
                html += '   </div>';
                html += '   <p class="double-row">' + userNameArr[i] + '</p>';
                html += '</div>';
            }
        }
        return html;
    }
    //渲染办理人
    function RenderTransactor(type) {
        var userIds, userNames, userPics;
        if (type == "user") {
            userIds = sessionStorage.getItem(Constant.TransactorPre + Constant.UserIDList);
            userNames = sessionStorage.getItem(Constant.TransactorPre + Constant.UserNameList);
            userPics = sessionStorage.getItem(Constant.TransactorPre + Constant.UserPic);
			sessionStorage.setItem("UserListExist", "1");
        } else {
            userIds = sessionStorage.getItem(Constant.TransactorPre + Constant.DeptIDList);
            userNames = sessionStorage.getItem(Constant.TransactorPre + Constant.DeptNameList);
            userPics = sessionStorage.getItem(Constant.TransactorPre + Constant.DeptPic);
            sessionStorage.setItem("DeptListExist", "1");
        }
        var html = RenderUserHtml(type, userIds, userNames, userPics);
        $(".transactor-group").prepend(html);
    }
    //清除办理人
    function RemoveTransactor() {
        $(".transactor-group .item-person").has("div.delete").remove();
    }
    //拼接办理人json串
    function GetAcceptUserInfo(){
        var arr = [];
        $(".item-person input:hidden").each(function () {
            arr.push({appFieldName: $(this).attr("id"),appFieldType: null,appFieldValue: "",mes:null,success: 1});
        });
        return arr;
    }
    //获取用户id字符串
    function GetUserIds() {
        var userIds = "";
        $(".item-person input.user:hidden").each(function () {
            userIds += $(this).attr("id") + ";";
        });
        if (userIds.length > 0) userIds = userIds.substr(0, userIds.length - 1);
        return userIds;
    }
    //获取部门id字符串
    function GetDeptIds() {
        var userIds = "";
        $(".item-person input.dept:hidden").each(function () {
            userIds += $(this).attr("id") + ";";
        });
        if (userIds.length > 0) userIds = userIds.substr(0, userIds.length - 1);
        return userIds;
    }
    //初始化事件
    function InitEvent() {
        //显示删除人员图标
        $('.item-person').on('longTap',function(){
            $(this).find('.fa-times-circle').removeClass('hide');
        });
        //显示删除人员确认对话窗
        $('.item-person .fa-times-circle').on('click', function () {
            $('.ui-actionsheet-wrap').removeClass('hide');
        });
        //添加办理人
        $('.add-transactor').on('click', function () {
            var uids = GetUserIds();
            var dids = GetDeptIds();
            var ids = uids.split(";").concat(dids.split(";")).join(";");
            sessionStorage.setItem("inputID", Constant.TransactorPre);
            sessionStorage.setItem(Constant.UserListIDS, ids);
            var isMul = store.get("isMulti");
            var nextJson=store.get("NextJson");
            if(nextJson.wfNextStepList && nextJson.wfNextStepList.length>0){
	        	$.each(nextJson.wfNextStepList,function(index,part){
	        		if(part.acceptUserInfo.length>0){
	        			if (isMul == '0'){
	                    	window.location = 'singleSelectColleague.html';
	                    } else {
	                    	window.location = 'selectColleague.html';
	                    }
	        		}else{
                        var saas = store.get("saas");
	                    window.location = '../../view/common/setUser.html?title=选择人员&deptId='+saas.saasOrgId;
	        		}
	        	});
	        }
            return false;
        });
        //头像加载错误则显示默认图片
        $(".item-person img").on("error", function () {
            $(this).attr("src", "../../styles/images/User.png");
        });
        //点击取消按钮
        $("#cancel").on('click',function(){
            history.go(-1);
        });
    }
    //页面加载完毕
    $(function () {
        if (sessionStorage.getItem(Constant.UserListExist) == "1") {
        	try {
        		var img = store.get("ImageCache");
        		if (img) $(".upload-pic").html(img);
        		var bigimg = store.get("BigImageCache");
        		if (bigimg) $('#bigImg').html(bigimg);
        		var voice = store.get("VoiceCache");
        		if (voice) $('#divVoice').html(voice);
        		var handsign=store.get("handsignSrc");
        		if (handsign) $('#curImg_handSign1').html('<img src="'+handsign+'" width="100%" height="auto" />');
        	} catch (e) { }  
            RenderTransactor("user");
            sessionStorage.removeItem(Constant.UserListExist);
        } else {
        	store.remove("ImageCache");
            store.remove("BigImageCache");
            store.remove("VoiceCache");
        }
        if (sessionStorage.getItem(Constant.DeptListExist) == "1") {
        	try {
        		var img = store.get("ImageCache");
        		if (img) $(".upload-pic").html(img);
        		var bigimg = store.get("BigImageCache");
        		if (bigimg) $('#bigImg').html(bigimg);
        		var voice = store.get("VoiceCache");
        		if (voice) $('#divVoice').html(voice);
        		var handsign=store.get("handsignSrc");
        		if (handsign) $('#curImg_handSign1').html('<img src="'+handsign+'" width="100%" height="auto" />');
        	} catch (e) { }  
            RenderTransactor("dept");
            sessionStorage.removeItem(Constant.DeptListExist);
        } else {
        	store.remove("ImageCache");
            store.remove("BigImageCache");
            store.remove("VoiceCache");
        }

        var strappID = store.get("WF_AppId"), strAppTId = store.get("WF_Tem"), strButton = '2';
        var strVersion = store.get("WF_Ver"), strcondition = store.get("WF_Condition"), intNewFlag = store.get("WF_New");
        getStartAppTemInfo(strappID, strAppTId, strVersion, strButton, strcondition, intNewFlag);

        InitEvent();
       //点击短语
        $('#phraseBar').on('click',function(){
            if($('#phrase').size()>0){
                $('#phraseBg,#phrase').removeClass("hidden");
            }else{
                Phrase.getPhrase("txtCallText");
            }
        })
    });

    //流程提交
    $("#saveAddGoods").on("click", function () {
    	store.remove("handsignSrc");
    			//通用业务数据处理
		if (!ExE_Business()) {
			return false;
		}
        var smsTransactFlag = "0";
        var copyFlag = "0";
        var callCheckFlag = $("#chkEndCall").attr("checked") ? 1 : 0;
        var smsFlag = 0;
        var buttonValue = "";
        var buttonId = "2";

        var appID = store.get("WF_AppId"); //流程Id   
        var appIdea = $("#txtCallText").val();//store.get("AppIdea") == null ? "" : store.get("AppIdea"); //办理意见
        var appTID = store.get("WF_Tem"); //流程模板ID”,      
        var appTitle = store.get("WF_appTitle"); //流程标题”
        var version = store.get("WF_Ver"); //流程版本”,     		
        var intNextStepId = store.get("NextStep") == null ? "" : store.get("NextStep"); //下一步步骤id
        var appOId = store.get("WF_appOId");
        var appOValue = store.get("WF_appOValue");
        var isNewFlag = store.get("WF_New"); // "0";

        var isOrder = "";
        var maxCount = "";
        var isJump = "";
        var promptContent = $("#txtCallText").val(); //结束通知的内容

        var isMulti = "0";
        var transactMode = "0";

        //通知人
        var callUsers = "";
        var callUsers1 = "";
        if (buttonId == "9" && callUsers != '') {
            arrCallUser = callUsers.split(',');
            for (i = 0; i < arrCallUser.length; i++) {
                callUsers1 += '{"appFieldName": "' + arrCallUser[i] + '","appFieldType": null,"appFieldValue": ""},';
            }
            if (callUsers1.length > 0) callUsers1 = callUsers1.substring(0, callUsers1.length - 1);
            callUsers = '"callUsers": {"stepUser": [{"acceptUserInfo":[' + callUsers1 + ']}],"mes":null,"success": 1}';
        }
        else {
            callUsers = '"callUsers": {"stepUser": [],"mes":null,"success": 1}'
        }
        //通知人结束
        //分发人
        var distributeUsers = "";
        callUsers1 = "";
        if (buttonId == "9" && distributeUsers != '') {
            arrCallUser = distributeUsers.split(',');
            for (i = 0; i < arrCallUser.length; i++) {
                callUsers1 += '{"appFieldName": "' + arrCallUser[i] + '","appFieldType": null,"appFieldValue": "","mes": null,"success": 1},';
            }
            if (callUsers1.length > 0) callUsers1 = callUsers1.substring(0, callUsers1.length - 1);
            distributeUsers = '"distributeUsers": [' + callUsers1 + ']';
        }
        else {
            distributeUsers = '"distributeUsers":null';
        }
        //分发结束  
        //下一步接收人
        var acceptUserInfo = GetAcceptUserInfo();
        if(buttonId == "2"){
            distributeUsers = '"distributeUsers":' + JSON.stringify(acceptUserInfo);
        }
        
        if(acceptUserInfo.length==0){
            toast("请选择办理人！");
            return false;
        }
        //下一步接收人结束
        //转下一步步骤列
        var nextStepList = '{"wfNextStepList":[{"acceptUserInfo":' + JSON.stringify(acceptUserInfo) + ',"callFlag":"1","isMulti":null,"nextStepID":"' + intNextStepId + '","nextStepName":null,"smsFlag":"0","transactMode":null,"mes":null,"success":1}],"mes": null,"success": 1}';
        //转下一步步骤列结束
        //新接口调用
        //var strdata = '{"sign":"' + appSign + '","button":{"appFlag":"2","appID":"' + appID + '","appIdea":"' + appIdea + '"';
        var strdata = '{"button":{"appFlag":"2","appID":"' + appID + '","appIdea":"' + appIdea + '"';
        strdata += ',"appTID":"' + appTID + '","appTitle":"' + appTitle + '","businessData":null,"buttonValue":"' + buttonValue + '","buttonId":"' + buttonId + '"';
        strdata += ',"callCheckFlag":"' + callCheckFlag + '","copyFlag":"' + copyFlag + '",' + callUsers + ',' + distributeUsers;
        strdata += ',"isJump":"' + isJump + '","isNewFlag":"' + isNewFlag + '","isOrder":"' + isOrder + '","maxCount":"' + maxCount + '"';
        strdata += ',"nextStepList":' + nextStepList;
        strdata += ',"promptContent":"' + promptContent + '","smsTransactFlag": "' + smsTransactFlag + '","version":"' + version + '","mes": null,"success": 1}';
        strdata += ',"appOId":"' + appOId + '","appOValue":"' + appOValue + '"}';
        //alert(strdata);
        //return ;
       //新接口调用
        var url= "api/WorkFlow/WorkFlowDeal";
        var param=strdata;
        var data=GetDataByUrl_Post(url,param);
        var json = JSON.stringify(data);
        //alert(json);
        if (data.success == "1") {
            //window.location.href = "myDoneApproval.html";
            if (appType == "weixin") {

            }
            else {
                if (data.mes && data.mes.indexOf("|") >= 0) {
                    SaveFileList(data.mes.split("|")[1]);
                } else {
                    SaveFileList();
                }
            }
            if (appType == "weixin") {
                //微信保存附件
                if (data.mes && data.mes.indexOf("|") >= 0) {
                    uploadobj.wxuploadImgVoi(data.mes.split("|")[1], "", "workflow");
                }
                else {
                    uploadobj.wxuploadImgVoi(appID, "", "workflow");
                }
				if(store.get("browser")=="1"){
					goHome(-2);
				} else {
					window.location.href = "myWaitApproval.html";
				}
            } else {
            	if (store.get("newWebView")=="1") {//如果是1关闭当前WebView
            		if(store.get("browser")=="1"){
						goHome(-2);
					} else {
						goHome("", "yes");
					}
		    	} else {
		    		window.location.href = "myWaitApproval.html";
		    	}
            }
        } else {
            toast(data.mes);
        }

        /* 旧接口 $.ajax({ type: 'post', data: strdata,
            url: hostUrl + "WorkFlowDeal",
            async: false,
            dataType: "json",
            contentType: "application/json;charset=utf-8",
            // headers: { "ApplicationContext": BaseHeader },
            success: function (data) {
                var json = JSON.stringify(data);
                //alert(json);
                if (data.success == "1") {
                    //window.location.href = "myDoneApproval.html";
                    if (data.mes && data.mes.indexOf("|") >= 0) {
                        SaveFileList(data.mes.split("|")[1]);
                    } else {
                        SaveFileList();
                    }
                    window.location.href = "index.html";
                } else {
                    toast(data.mes);
                }
            }
        });*/

    });

    //流程转下一步信息
    function getStartAppTemInfo(strappID, strAppTId, strVersion, strButton, strcondition, intNewFlag) {
         //新接口调用
        //var oData = '{"sign":"' + appSign + '","appID":"' + strappID + '","appTID":"' + strAppTId + '","appVersion":"' + strVersion + '","ButtonType":"' + strButton + '","condition":"' + strcondition + '","isNewFlag":"' + intNewFlag + '"}';
        var oData = '{"appID":"' + strappID + '","appTID":"' + strAppTId + '","appVersion":"' + strVersion + '","ButtonType":"' + strButton + '","condition":"' + strcondition + '","isNewFlag":"' + intNewFlag + '"}';
        var url= "api/WorkFlow/GetWFStepInfo";
        var param=oData;
        var data=GetDataByUrl_Post(url,param);
        //alert(oData)
        json = data;

        var curStepId = "";
		var isMulti = "";
        //流程可操作按钮
        if (json.wfNextStepList && json.wfNextStepList.length > 0) {
            curStepId = json.wfNextStepList[0].nextStepID;
			isMulti = json.wfNextStepList[0].isMulti;
            $(".nextDep").val(json.wfNextStepList[0].nextStepName);
			store.set("isMulti", isMulti);
        }
        //缓存流程数据，弹出页面使用
        store.set("NextJson", json);
        store.set("NextStep", curStepId);
        store.set("NextXH", 0);
        /*$.ajax({ type: 'post', data: oData,
            url: hostUrl + "GetWFStepInfo",
            async: false,
            dataType: "json",
            contentType: "application/json;charset=utf-8",
            // headers: { "ApplicationContext": BaseHeader },
            success: function (data) {
                //var json = JSON.stringify(data);
                //alert(json);
                //json = JSON.parse(json);
                json = data;

                var curStepId = "";
                //流程可操作按钮
                if (json.wfNextStepList && json.wfNextStepList.length > 0) {
                    curStepId = json.wfNextStepList[0].nextStepID;
                    $(".nextDep").val(json.wfNextStepList[0].nextStepName);
                }
                //缓存流程数据，弹出页面使用
                store.set("NextJson", json);
                store.set("NextStep", curStepId);
                store.set("NextXH", 0);

            }
        });  */
    }
});