define(['swiper', 'base64'], function() {
    //常量
    var Constant = {
        OpinionPic: "WorkFlow_OpinionPic_", //图片json串在sessionStorage的键前缀
        OpinionAudio: "WorkFlow_OpinionAudio_", //音频json串在sessionStorage的键前缀
        OpinionVideo: "WorkFlow_OpinionVideo_" //视频json串在sessionStorage的键前缀
    }
    //页面全局变量
    var Global = {
        OpinionBigPicSwiper: null, //审批意见大图滚动查看对象
        AudioDeleteIndex: -1, //待删除的音频在音频列表中的下标
        VideoDeleteIndex: -1 //待删除的视频在音频列表中的下标
    }


    //加载已上传的图片
    window.setLocalImgInfo = function(jsonStr, tagJson) {
        var retStr = uploadobj.imgback(jsonStr);
        if (retStr != "" && retStr != 'undefined' && typeof retStr != undefined) {
            var imageJson = JSON.parse(retStr);


            $('.upload-pic').append(imageJson.xiaoImgContent);

            if ($('.upload-pic').html() != "") {
                $('.upload-pic').show();
            }
            $('#bigImg').append(imageJson.daImgContent);

            //图片缓存
            store.set("ImageCache", $('.upload-pic').html());
            store.set("BigImageCache", $('#bigImg').html());
        }
    }

    //加载已上传的语音
    window.setAudioInfo = function(jsonStr, tagJson) {
        var retStr = uploadobj.voiback(jsonStr, tagJson);
        if (retStr != "" && retStr != 'undefined' && typeof retStr != undefined) {
            var voiceJson = JSON.parse(retStr);

            $('#divVoice').append(voiceJson.voiceStr);
            if ($('#divVoice').html() != "") {
                $('#divVoice').show();
            }
            //语音缓存
            store.set("VoiceCache", $('#divVoice').html());

        }
    }

    //保存审批意见文件列表
    window.SaveFileList = function(id) {
        var flag = false;
        var data = {
            sign: appSign,
            fileList: uploadobj.getapprovefiles(id)
        };
        //意见签批保存
        if($('#imgs_handSign1').size()>0 && $('#curImg_handSign1').html()!=''){
        	if(id==undefined || id=='undefined' || id=='' || id==null){
        		id=store.get("WF_AppId");
        	}
			saveHandSign(id);
		}
        if (data.fileList.length == 0) return true;
        //alert(JSON.stringify(GetFileList(id)));
        var datajson = GetDataByUrl_Post("api/WorkFlow/upLoadFile", JSON.stringify(uploadobj.getapprovefiles(id)));
        if (datajson.success == "1") {
            flag = true;
        } else {
            toast(datajson.mes);
        }
        store.remove("ImageCache");
        store.remove("BigImageCache");
        store.remove("VoiceCache");
        return flag;
    }
    
    //审批意见签批事件
	function saveHandSign(bizId){
		var handSignUrl='api/Signature/saveHandWrite',
			signature=$('#curImg_handSign1 img').attr('src');
		var para={bizId:bizId,bizFieldId:'handSign1',signature:signature};
		var data=GetDataByUrl_Post(handSignUrl, JSON.stringify(para));
	}
    //审批意见图片事件
    function InitOpinionPicEvent() {
        //上传图片
        $('.upload .fa-camera').click(function() {
            var curImg = uploadobj.imgcount();
            if (curImg >= 5) {
                toast("图片已到最大张数！", "", 1500);
                return false;
            }
            if (appType == "weixin")
                uploadobj.uploadimg(5 - curImg, 0, "1");
            else
                uploadobj.uploadimg(5 - curImg, 2, "1");
        });
    }
    //审批意见音频事件
    function InitOpinionAudioEvent() {
        //录音
        $('.upload .fa-microphone').click(function() {
            var curVoice = uploadobj.voicount();
            if (curVoice >= 5) {
                toast("已经达到最大数量！", "", 1500);
                return false;
            }
            uploadobj.uploadvoi(300000, 1000, 1, "1");
        });
    }




    //页面加载完毕
    $(function() {
        //InitOpinionPic();
        //InitOpinionAudio();
        //InitOpinionVideo();
        //InitOtherEvent();
        InitOpinionPicEvent();
        InitOpinionAudioEvent();
        //InitOpinionVideoEvent();
        
    });

    //图片放大及删除
    $('.upload-pic').on('click', 'img', function() {
        var index = $(this).parent().index();
        $('.photo-big').removeClass('hide');
        mySwiper.update();
        mySwiper.slideTo(index);
        sessionStorage.setItem("img", index);
    })
     $('.upload-pic').on('click', '.icon-close-img', function() {
        var index = $(this).parent().index();
        sessionStorage.setItem("img", index);
        $('.ui-actionsheet-wrap').eq(0).removeClass('hide');
        $('.ui-actionsheet-wrap').eq(0).find('.title').text('确定要删除吗？');
    });


    $(document).on('click', '.back', function() {
       $('.photo-big').addClass('hide');
        $('.ui-actionsheet-wrap').eq(0).addClass('hide');
        $('.ui-actionsheet-wrap').eq(0).find('.title').text('确定要删除吗？');
    });
    $(document).on('click', '.deleteImg', function() {
        //大图删除当前图片
        $('.photo-big').addClass('hide');
        $('.ui-actionsheet-wrap').eq(0).removeClass('hide');
        $('.ui-actionsheet-wrap').eq(0).find('.title').text('确定要删除吗？');
        $('#bigImg .swiper-slide').each(function(index) {

            if ($(this).attr("class") == "swiper-slide swiper-slide-active") {
                sessionStorage.setItem("img", index);
            }
        });
    });

    var mySwiper = new Swiper('.swiper-container', {
        pagination: '.swiper-pagination',
        paginationClickable: true
    });
    //播放音乐
    $(document).on('tap', '.playMP3', function() {
        $('.audio').removeClass('hide');
        var $ul = $(this).find('span[class="hidden"]').attr('url');

        var mname = $(this).find('span[class="hidden"]').prev().html();

        if ($ul) {
            if ($ul.lastIndexOf(".mp3") < 0) {
                $ul = $ul + '.mp3';
            }
            $('#audio').attr('src', $ul);
            $('#MusicName').html(mname);
        }
        $('.u-my-diary').addClass('fix-bottom');
        audio.play();
    });
    $(document).on('tap', '.audio .btn', function() {
        $(this).parent().addClass('hide');
        $('.u-my-diary').removeClass('fix-bottom');
        audio.pause();
    });
    var audio = document.getElementById("audio");
    $(document).on('tap', '.file-type', function() {
        if (audio.paused) {
            audio.play();
            return false;
        } else {
            audio.pause();
        }
    });
    //删除 rar mp3
    $(document).on('tap', '.icon-close', function() {     
        $('.icon-close').each(function (index) {
             $(this).unbind('click');
             $(this).bind('click', function () {
                 sessionStorage.setItem('voice', index);
                 $('.ui-actionsheet-wrap').eq(0).removeClass('hide');
                 $('.ui-actionsheet-wrap').eq(0).find('.title').text('确定要删除' + $(this).parent().find('.name').text() + ' 吗?');
             }).on('longTap', function () {
                 sessionStorage.setItem('voice', index);
                 $('.ui-actionsheet-wrap').eq(0).removeClass('hide');
                 $('.ui-actionsheet-wrap').eq(0).find('.title').text('确定要删除' + $(this).find('.name').text() + ' 吗?');
             });
         });
    })
    $('#back').on('click', function () {
        if (appType == "weixin" || appType == "ding") { uploadobj.stopvoi(); }
        $('.ui-actionsheet-voice').addClass('hide');
    });




    //长按后的删除
    $(document).on('click', '#deleted', function() {
        //alert('删除当前图片11111');
        //清除语音元素
        if (appType == "weixin" || appType == "ding") {
            uploadobj.commitvoi(); $('.ui-actionsheet-voice').addClass('hide'); $('.ui-actionsheet-wrap').addClass('hide');return false;
        }
        if (sessionStorage.getItem('voice') != null) {
            var item = -1;
            $('.icon-close').each(function(index) {
                item = sessionStorage.getItem('voice');

                if (item == index) {
                    $(this).parent().remove();
                    $(this).remove();
                    sessionStorage.removeItem('voice');
                }
                if ($('#divVoice').html() == "") {
                    $('#divVoice').hide();
                }
            });
        }
        else {
            var item = -1;
            $('.upload-pic img').each(function(index) {
                item = sessionStorage.getItem('img');

                if (item == index) {
                    //alert(item);
                    $(this).parent().remove();
                    $(this).remove();
                    $('#bigImg .swiper-slide img').eq(index).parent().remove();
                    sessionStorage.removeItem('img');
                }
                if ($('.upload-pic').html() == "") {
                    $('.upload-pic').hide();
                }
            });
        }
        //图片缓存
        store.set("ImageCache", $('.upload-pic').html());
        store.set("BigImageCache", $('#bigImg').html());
        //语音缓存
        store.set("VoiceCache", $('#divVoice').html());
        $('.ui-actionsheet-wrap').eq(0).addClass('hide');
    });
});