define(['mobilekit', 'datetime'], function() {
	//常量
	var Constant = {
		AppTId: "ioa_officesupply"
	}

	function guid() {
		return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
			var r = Math.random() * 16 | 0,
				v = c == 'x' ? r : (r & 0x3 | 0x8);
			return v.toString(16);
		});
	}

	//表单初始化
	function InitForm() {
		//初始化领用时间
		var timesys = getServiceCurDate();
		$('#systime').val(timesys);
		//初始化部门名称
		$('#txt-dept').val(appDeptName);
		//初始化人员姓名
		$('#txt-user').val(appUserName);

		//初始化流程标题
		if (store.get('goods_title') != null) { 
			$('#tit-input').val(store.get('goods_title')); 
		}
		//初始化仓库列表
		/* 注释掉旧的接口调用方案
		var jsonData = ajaxPost("GetOfficeSupplyStore", JSON.stringify({ 
			sign: appSign
		}));
		*/
		/* 新接口调用方案*/
        var jsonData = GetDataByUrl_Post("api/Form/GetOfficeSupplyStore",'');
		
		if (jsonData != "" && jsonData.success == 1) {
			var strHtml = "";
			var n = jsonData.list.length;
			if (n != 0) {
				for (var m = 0; m < n; m++) {
					
					var storeName = jsonData.list[m].storeName;
					var storeId = jsonData.list[m].storeID;
					strHtml += "<option value=\"" + storeId + "\">" + storeName + "</option>";
				}
			}
			$('#uc-input').html("");
			$(strHtml).appendTo($('#uc-input'));
		}
		if (store.get('goods_cangku') != null) {
			$('#uc-input').val(store.get('goods_cangku'));
		}
		//初始化明细数据
		$('#ul-wplb').append(store.get('goods_html'));
		var goodsinfo = store.get('goods_goods');
		if (goodsinfo != null) {
			var storeid = $('#uc-input').val();
			if (storeid != "") {
				store.set('goods_cangku', storeid);
			}
			var storename = $("#uc-input  option:selected").text();
			var hrefurl = "addGoods.html?guid=" + goodsinfo.guid;
			hrefurl += "&gtypename=" + goodsinfo.goodstype;
			hrefurl += "&gtypeid=" + goodsinfo.goodstypeid;
			hrefurl += "&name=" + goodsinfo.goodsname;
			hrefurl += "&id=" + goodsinfo.goodsnameid;
			hrefurl += "&num=" + goodsinfo.goodsnum;
			hrefurl += "&re=" + goodsinfo.goodsyongtu;
			hrefurl += "&dw=" + goodsinfo.goodsdanwei;
			hrefurl += "&si=" + storeid;
			hrefurl += "&sn=" + storename;
			var strHtml = "";
			strHtml += "<li id=\"" + goodsinfo.guid + "\" name=\"" + goodsinfo.goodsnameid + "\" class=\"table-view-cell\">";
			strHtml += "<a href=\"" + hrefurl + "\"  class=\"navigate-right\">";
			strHtml += "<img src=\"http://placehold.it/40x40\" alt=\"\"  class=\"media-photo\"/>";
			strHtml += "<div class=\"media-body\">";
			strHtml += "<span>" + goodsinfo.goodsname + "</span><span class=\"pull-right num\">" + goodsinfo.goodsnum + " " + goodsinfo.goodsdanwei + "</span>";
			strHtml += "<p class=\"text\">" + goodsinfo.goodsyongtu + "</p>";
			strHtml += "</div>";
			strHtml += "</a>";
			strHtml += "</li>";
			$('#ul-wplb').append(strHtml);

		}
		//如果有明细需要删除 进行删除
		if (store.get('delguid') != null) {
			var arrguid = store.get('delguid').split(',');
			for (var i = 0; i < arrguid.length; i++) {
				$("#" + arrguid[i]).remove();
			}
		}

	}

	function checkForm() {
		if (!$('#tit-input').val()) {
			$('#tit').addClass('show');
			$('#tit').removeClass('hide');
			$('#tit-input').closest('.form-control').addClass('error');
		}
		if (!$('#uc-input').val()) {
			$('#uc').addClass('show');
			$('#uc').removeClass('hide');
			$('#uc-input').closest('.form-control').addClass('error');
		}
		var flag = $('.fa-exclamation-circle').hasClass('show');
		if (flag) {
			return false;
		} else {
			return true;
		}
	}

	//初始化业务数据
	function InitBusinessData(strAppTitle, strAppOID, strAppOValue) {
		//拼接参数
		var jsonData = new Object();
		//jsonData.sign = appSign;
		jsonData.OffsFlowID = strAppOID;
		//调用接口方法获取业务数据
		//var dataJson = ajaxPost("GetOfficeSupplyMain", JSON.stringify(jsonData));
		var dataJson = GetDataByUrl_Post("api/Form/GetOfficeSupplyMain", JSON.stringify(strAppOID));
		//alert(JSON.stringify(dataJson));
		if (dataJson != null && dataJson.success == 1) {
			//加载主表信息
			$('#tit-input').val(strAppTitle);
			$('#systime').val(dataJson.offsSubTime);
			$('#txt-dept').val(dataJson.deptName);
			$('#txt-user').val(dataJson.userName);
			$('#uc-input').val(dataJson.offsStoreID);
			//加载明细信息 begin
			/*
			var dataSubJson = ajaxPost("GetOfficeSupplyDetail", JSON.stringify({
				sign: appSign,
				OffsFlowID: strAppOID
			}));*/
			var dataSubJson = GetDataByUrl_Post("api/Form/GetOfficeSupplyDetail", strAppOID);
			//alert(JSON.stringify(dataSubJson));
			if (dataSubJson != null && dataSubJson.success == 1) {
				var n = dataSubJson.list.length;
				if (n > 0) {
					for (var i = 0; i < n; i++) {
						var strGuid = guid();
						var storeid = dataSubJson.list[i].offsStoreID;
						var storename = dataSubJson.list[i].offsStoreName;
						var hrefurl = "addGoods.html?guid=" + strGuid;
						hrefurl += "&gtypename=" + dataSubJson.list[i].offstypename;
						hrefurl += "&gtypeid=" + dataSubJson.list[i].offstypeid;
						hrefurl += "&name=" + dataSubJson.list[i].offsName;
						hrefurl += "&id=" + dataSubJson.list[i].offsNumber;
						hrefurl += "&num=" + dataSubJson.list[i].offsAmount;
						hrefurl += "&re=" + dataSubJson.list[i].applyPurpose;
						hrefurl += "&dw=" + dataSubJson.list[i].offsUnit;
						hrefurl += "&si=" + storeid;
						hrefurl += "&sn=" + storename;
						var strHtml = "";
						strHtml += "<li id=\"" + strGuid + "\" name=\"" + dataSubJson.list[i].offsNumber + "\" class=\"table-view-cell\">";
						strHtml += "<a href=\"" + hrefurl + "\"  class=\"navigate-right\">";
						strHtml += "<img src=\"http://placehold.it/40x40\" alt=\"\"  class=\"media-photo\"/>";
						strHtml += "<div class=\"media-body\">";
						strHtml += "<span>" + dataSubJson.list[i].offsName + "</span><span class=\"pull-right num\">" + dataSubJson.list[i].offsAmount + " " + dataSubJson.list[i].offsUnit + "</span>";
						strHtml += "<p class=\"text\">" + dataSubJson.list[i].applyPurpose + "</p>";
						strHtml += "</div>";
						strHtml += "</a>";
						strHtml += "</li>";
						$('#ul-wplb').append(strHtml);
					}
				}
			} else {
				toast("获取物品明细失败！", "", 1500);
			}
			//加载明细信息 end
		} else {
			toast("获取业务数据失败！", "", 1500);
		}
	}

	//保存业务数据
	function SaveBusinessData() {
		var isnew = store.get("WF_New");
		//判断流程是否结束
		var intApproveFlag = store.get("WF_AppBtn")
		if (intApproveFlag == 9) //结束
			intApproveFlag = 1;
		else
			intApproveFlag = 2;

		//拼接业务数据
		var arraylist = new Array();
		$('#ul-wplb').find('li').each(function() {
			var listdata = new Object();
			listdata.ApplyPurpose = $(this).find('p').eq(0).html();
			listdata.OffsAmount = $(this).find('span').eq(1).html().split(' ')[0];
			listdata.OffsName = $(this).find('span').eq(0).html();
			listdata.OffsNumber = $(this).attr('name');
			arraylist.push(listdata);
		});
		var jsonSubData = new Object();
		jsonSubData.list = arraylist;
		var jsonData = new Object();
		jsonData.OffsStoreID = $('#uc-input').val();
		//jsonData.sign = appSign;
		if (isnew == "1") {
			jsonData.OffsFlowID = store.get("WF_appOId");
			jsonData.OffsAppflag = intApproveFlag;
		} else {
			jsonData.flag = intApproveFlag;
		}
		//jsonData.officeSupplyInfo = jsonSubData;
        jsonData.osil = jsonSubData;

		//缓存方法名
		var arrayMethod = new Array();
		if (isnew == "1")
			arrayMethod.push('api/Form/OfficeSupplyApprove');
		else
			arrayMethod.push('api/Form/OfficeSupplySave');
		store.set('EB_NAME', arrayMethod);
		//缓存方法参数
		var arrayParam = new Array();
		arrayParam.push(JSON.stringify(jsonData));
		store.set('EB_DATA', arrayParam);
		//缓存流程标题
		store.set('EB_TITLE', $("#tit-input").val());
		//缓存业务主键
		store.set('EB_ID', "");
		//缓存流程类型 0系统流程 1表单流程
		store.set('EB_TYPE', 0);
		return true;
	}

	//初始化其他事件
	function InitOtherEvent() {
		//输入框聚焦时变色
		$('.form-group').on('focus', 'input', function() {
			$(this).closest('.form-control').addClass('active');
		}).on('blur', 'input', function() {
			$(this).closest('.form-control').removeClass('active');
		});
		/*
		 * 显示/收缩审批流程
		 */
		$(document).on('click', '.vacation-process-title', function() {
		    $('.vacation-process-content').toggleClass('hide');
		    var $thisChildI = $(this).find("i");
		    $thisChildI.toggleClass("fa-caret-right");
		    $thisChildI.toggleClass("fa-caret-down");
		    document.documentElement.scrollTop = $(this).offset().top;
		    document.body.scrollTop = $(this).offset().top;
		});
		//验证
		$('#tit-input').on('blur', function() {
			if ($(this).val()) {
				$('#tit').addClass('hide');
				$('#tit').removeClass('show');
				$(this).closest('.form-control').removeClass('error');
			}
		}).on('focus', function() {
			$('#tit').addClass('hide');
			$('#tit').removeClass('show');
			$(this).closest('.form-control').removeClass('error');
		});
		$('#uc-input').on('blur', function() {
			if ($(this).val()) {
				$('#uc').addClass('hide');
				$('#uc').removeClass('show');
				$(this).closest('.form-control').removeClass('error');
			}
		}).on('focus', function() {
			$('#uc').addClass('hide');
			$('#uc').removeClass('show');
			$(this).closest('.form-control').removeClass('error');
		});

		$('#uc-input').on('change', function() {
			$('#ul-wplb').html("");
		});

		//点击添加按钮
		$('#btn-add').on('click', function() {
			var storeid = $('#uc-input').val();
			if (storeid != "") {
				store.set('goods_cangku', storeid);
			}
			var storename = $("#uc-input  option:selected").text();
			window.location.href = 'addGoods.html?si=' + storeid + '&sn=' + storename;
			var goodtitle = $('#tit-input').val();
			if (goodtitle != "") {

				store.set('goods_title', goodtitle);
			}

			store.set('goods_html', $('#ul-wplb').html());
			store.remove('goods_goods');
		});
	}

	//页面加载完毕
	$(function() {
		//初始化表单
		InitForm();

		//1流程添加：初始化(参数1：流程的类型id 参数2：取业务数据的方法名)
		BusinessApprove(Constant.AppTId, InitBusinessData);
		//1流程添加：初始化

		//初始化其他事件
		InitOtherEvent();

		//4流程添加：初始化流程流转按钮事件    
		InitApproveButtonEvent(Constant.AppTId, "", checkForm, SaveBusinessData);
		//4流程添加	
	});

});