(function($,window,document){
	/**
	 * 纵向滚动到底部/横向滚动到右侧 加载更多数据
	 * @method setScrollLoad
	 * @param [options] 实例化参数,具体的参数如下:<br/>
	 *  。"direction"（默认为：portrait）:滚动的方向(portrait纵向滚动和landscape横向滚动)<br/>
	 * 	。"scrollAjax" (默认为true): 是否用内置的ajax(true:表示用内置的ajax,false:表示不用内置的ajax)<br/>
	 * 	。"scrollAjaxUrl": 内置ajax 请求路径 <br/>
	 * 	。"scrollAjaxType": 内置ajax 请求方式，默认为'GET'方法 <br/>
	 * 	。"scrollAjaxDataType": 内置ajax 返回数据类型' <br/>
	 * 	。"scrollAjaxData": 内置ajax 请求参数' <br/>
	 * 	。"scrollAjaxSuccess": 内置ajax 请求成功时的回调函数' <br/>
	 * 	。"scrollAjaxError": 内置ajax 请求失败时的回调函数' <br/>
	 * 	。"content": 如果不用内置的ajax时，执行的回调函数(即:scrollAjax设为false后，会执行这个回调函数)' <br/>
	 * 	。"refreshData":是否有刷新功能' <br/>
	 * 	。"scrollFlag":是否允许滚动加载功能’ <br/>
	 */
	$.fn.endlessScroll = function(options){
		return new EndlessScroll(this,options);
	}
	var EndlessScroll = function(element,options){
		this.ele = element || $(window);
		if(element[0] == document){
			this.ele = $(window);
		}
		this.scrollAjaxLocker = true;// 是否允许加载数据
		this.defaults = {
			scrollAjax: true,
			scrollAjaxUrl: '',
			scrollAjaxType: 'GET',
			scrollAjaxDataType: 'json',
			scrollAjaxData:{},
			scrollAjaxSuccess: '',
			scrollAjaxError: '',
			content:'',
			direction: 'portrait', //默认纵向
			refreshData:false,//是否允许有刷新
			scrollFlag:true,//是否允许滚动加载功能
			refreshNotice:true//是否刷新有提示
		};
		this.options = $.extend({},this.defaults, options);
		this.init();
	}
	/**
	 * 初始化
	 */
	EndlessScroll.prototype.init = function(){
		var self = this;
		window.__beforeScrollTop = $(window).scrollTop();
		this.ele.on('scroll',function(){
			switch(self.options.direction){
				case 'portrait':
					self.scrollAjaxLocker && self.options.scrollFlag  && self.verticalScroll();
					break;
				case 'landscape':
					self.scrollAjaxLocker && self.horizentalScroll();
					break;
				default:
					alert('direction 参数值有误');
			}
		});
		if(self.options.refreshData==true){
			self.verticalScrollRefresh();
		}
	}

	/**
	 *  判断纵向是否滚动到底部
	 */
	EndlessScroll.prototype.verticalScroll = function(){
		//$('.list-loading').removeClass('hide');
		if($('.ui-notice').length==0&&$('.list-donetip').hasClass('hide')){
			$('.list-loading').removeClass('hide')
		}else{
			$('.list-loading').addClass('hide')
		}
		var scrollTop = this.ele.scrollTop();//获取垂直滚动的距离(滚动到的当前位置)
		var viewH = this.ele.height();//可见高度（浏览器高度或者div高度）
		var contentH = this.ele[0] == window ? $(document).height() : this.ele[0].scrollHeight;//获取整个页面的高度
		if(contentH  <= scrollTop + viewH){//表明已经滚距离页面底部100px,开始加载数据
			setload = 1;

			var dataNum=this.hasContent();
			if(dataNum==0 && setload==1 && $('.ui-notice').length==0){
				$('.list-loading').addClass('hide');
				$('.list-donetip').removeClass('hide');

			}else if(dataNum!=0 && setload==1){
				//$('.list-loading').removeClass('hide');
				$('.list-donetip').addClass('hide');
			}
			/*if(dataNum!=0 && setload==-1 && !isNaN(dataNum)==true){
				toast("又发现"+dataNum+"条新内容", "", 1000);
			}else if(dataNum==0 && setload==-1){
				toast("已是最新内容", "", 1000);
			}else if(dataNum==0 && setload==1){
				$('.list-loading').addClass('hide');
				$('.list-donetip').removeClass('hide');
			}*/

		}
	}
	/**
	 *  判断纵向是否下拉刷新
	 */
	EndlessScroll.prototype.verticalScrollRefresh = function(){
		var _this=this;
		var slide = function (option) {
			var defaults={
				container:'',
				next:function(){}
			}
			var start,
				end,
				length,
				isLock = false,//是否锁定整个操作
				isCanDo = false,//是否移动滑块
				isTouchPad = (/hp-tablet/gi).test(navigator.appVersion),
				startTime,
				hasTouch = 'ontouchstart' in window && !isTouchPad;
			var obj = option.container;
			var loading=$(".pullrefresh-dragtip");
			var offset=loading[0].clientHeight;
			//var objparent = $('body')[0];
			/*操作方法*/
			var fn =
			{
				//移动容器
				translate: function (diff) {
					loading.css({'transform':'translate3d'+'(0,'+diff+'px,0)','-webkit-transform':'translate3d'+'(0,'+diff+'px,0)'});
					loading.find('span').css({'transform':'rotate('+diff*4+'deg)'});
				},
				//设置效果时间
				setTransition: function (time) {
					loading.css({'transition':'all '+time+'s','-webkit-transition':'all '+time+'s'});
					loading.find('span').css('transition','all '+time+'s');
				},
				//返回到初始位置
				back: function () {
					fn.translate(0);
					//标识操作完成
					isLock = false;
				},
				addEvent:function(element,event_name,event_fn){
					if (element.addEventListener) {
						element.addEventListener(event_name, event_fn, false);
					} else if (element.attachEvent) {
						element.attachEvent('on' + event_name, event_fn);
					} else {
						element['on' + event_name] = event_fn;
					}
				}
			};
			fn.translate(0);
			fn.addEvent(obj[0],'touchstart',startFn);
			fn.addEvent(obj[0],'touchmove',moveFn);
			fn.addEvent(obj[0],'touchend',endFn);

			//滑动开始
			function startFn(e) {
				startTime=new Date()*1;
				if (obj.scrollTop() <= 0 && !isLock) {
					var even = typeof event == "undefined" ? e : event;
					//标识操作进行中
					isLock = true;
					isCanDo = true;
					//保存当前鼠标Y坐标
					start = hasTouch ? even.touches[0].pageY : even.pageY;
					//消除滑块动画时间
					fn.setTransition(0);
					loading.innerHTML='下拉刷新数据';
				}
				return false;
			}

			//滑动中
			function moveFn(e) {
				if (obj.scrollTop() <= 0 && isCanDo) {
					var even = typeof event == "undefined" ? e : event;

					//保存当前鼠标Y坐标
					end = hasTouch ? even.touches[0].pageY : even.pageY;
					if (start < end) {
						even.preventDefault();
						//消除滑块动画时间
						fn.setTransition(0);
						//移动滑块
						if((end-start-offset)/2<=150) {
							length=end-start+44;
							length=length>180?180:length=length;
							fn.translate(length);
						}
						else {
							length+=0.3;
							fn.translate(length);
						}
					}
				}
			}
			//滑动结束
			function endFn(e) {
				if (isCanDo) {
					isCanDo = false;

					var Times=new Date()*1-startTime;
					//判断滑动距离是否大于等于指定值
					if (end - start >= 180 && Times>200) {

						Time=0;
						//设置滑块回弹时间
						fn.setTransition(1);
						//保留提示部分
						fn.translate(0);
						if (typeof option.next == "function") {
							option.next.call(fn, e);
						}
					} else {
						//返回初始状态
						fn.back();
					}
				}
			}
		}
		slide({container:this.ele,next: function (e) {
			//松手之后执行逻辑,ajax请求数据，数据返回后隐藏加载中提示
			var that = this;
			setload = -1;
			setTimeout(function () {
				that.back.call();
				var dataNum=_this.hasContent();
				if(dataNum!=0 && setload==-1 && !isNaN(dataNum)==true){
				    //toast("又发现"+dataNum+"条新内容", "", 1000);
				    toast("已是最新内容", "", 1000);
				}else if(dataNum==0 && setload==-1){
					toast("已是最新内容", "", 1000);
					$('.list-loading').addClass('hide');
					//$('.list-donetip').addClass('hide');
				}

			}, 500);
		}});

	}

	/**
	 * 判断横向是否滚动到右侧
	 */
	EndlessScroll.prototype.horizentalScroll = function(){
		setload = 1;
		var scrollLeft = this.ele.scrollLeft();//获取水平滚动条的距离
		var scrollWidth = this.ele.width();//可见宽度
		var contentW = this.ele[0].scrollWidth;
		if(contentW <= scrollLeft + scrollWidth){
			this.hasContent();
		}
	}
	/**
	 * 判断是否用内置的ajax
	 */

	EndlessScroll.prototype.hasContent = function(){
		if(this.options.scrollAjax && this.options.scrollAjaxUrl){
			this.scrollAjax();
		}else{
			if( typeof this.options.content == 'function'){
				//this.options.content();
				return this.options.content();
			}
		}
	}
	/**
	 * 内置ajax实现
	 */
	EndlessScroll.prototype.scrollAjax = function(){
		var self = this;
		$.ajax({
			url: this.options.scrollAjaxUrl,
			type: this.options.scrollAjaxType,
			dataType: this.options.scrollAjaxDataType,
			data: this.options.scrollAjaxData,
			beforeSend: function(){
				self.scrollAjaxLocker = false; //ajax 上锁
			},
			success: function(data){
				if( typeof self.options.scrollAjaxSuccess == 'function'){
					var state = self.options.scrollAjaxSuccess(data,self.options.scrollAjaxData);
					if(state === false){
						return;
					}else if(state == Object){
						self.options.scrollAjaxData = state;
					}
					self.scrollAjaxLocker = true;//ajax 解锁
				}
			},
			error: function(e){
				if( typeof self.options.scrollAjaxError == 'function'){
					self.options.scrollAjaxError(e);
				}
				self.scrollAjaxLocker = true;//ajax 解锁
			}
		})
	}
})(window.Zepto,window,document);