/**
 * 对highcharts的封装,自动配置属性
 * @author shaoar
 */

var _options = {
		title:{text:null},
		chart:{renderTo: 'container',borderWidth: 1,borderColor: '#4572A7',marginRight:null},
		credits:{enabled: true,href: '',text: ''},
		exporting:{enabled: true,filename: 'chart',url: 'http://export.highcharts.com'},
		legend:{enabled: true,layout: 'horizontal',align: 'center',verticalAlign: 'bottom',borderWidth: 1,borderColor: '#909090'},
		xAxis: {type: 'linear',tickPixelInterval: null,tickColor: '#C0D0E0',tickWidth: 1,reversed: false},
		tooltip:{crosshairs: false,shared: false,shadow: true,headerFormat:'<span><b>{point.key}</b></span><br/>',pointFormat:'<span style="color:{series.color}">{series.name}: <b>{point.y}</b></span>'},
		plotOptions: {area: {stacking: null}},
		series: {dataLabels: {enabled: true}}
};
/**
*@param model highchatts接口的model对象
*@param url 生成报表的url
*@param optionsJson 接口生成报表的json串
*@author shaoairong
*/
var Jc6Highcharts = function(model,url,optionsJson){
	var chart;
	var options;
	var backgroundColor;
	var url=url;
	 options = ({  
            chart: {  
	            //将报表对象渲染到层上  
	            renderTo: _options.chart.renderTo,
	            borderWidth: _options.chart.borderWidth,
	            borderColor: _options.chart.borderColor,
	            marginRight:_options.chart.marginRight,
          		spacingRight: 30
          		//marginRight: 30
	           /* 动态曲线
	            animation: Highcharts.svg,
	            events: {                                                           
                    load: function() {                                              
                                                                                    
                        // set up the updating of the chart each second             
                        var series = this.series[0];                                
                        setInterval(function() {                                    
                            var x = (new Date()).getTime(), // current time         
                                y = Math.random();                                  
                            series.addPoint([x, y], true, true);                    
                        }, 1000);                                                   
                    }                                                               
                }
                */                                                                   
	        },
	        colors:[
                       '#2f7ed8', 
					   '#0d233a', 
					   '#8bbc21', 
					   '#910000', 
					   '#1aadce', 
					   '#492970',
					   '#f28f43', 
					   '#77a1e5', 
					   '#c42525', 
					   '#a6c96a'
						//添加更多的颜色
                      ],
	        exporting:{
	        	enabled: _options.exporting.enabled,
	        	filename:  _options.exporting.filename,
	        	url: _options.exporting.url
	        },  
	        title: {
	            text: _options.title.text
	        },
	        legend:{
	        	enabled: _options.legend.enabled,
	        	layout: _options.legend.layout,
	            align: _options.legend.align,
	            verticalAlign: _options.legend.verticalAlign,
	            borderWidth: _options.legend.borderWidth,
	            borderColor: _options.legend.borderColor
	        },
        	subtitle: {
	            text: null
	        },
	        credits:{
	        	enabled: _options.credits.enabled,
	        	text: _options.credits.text,
	        	href: _options.credits.href,
	        	position: {
					align: 'right',
					x: -10,
					verticalAlign: 'bottom',
					y: -10
				}	
	        },
	        xAxis: {  
	            showEmpty: false,
	       		reversed: _options.xAxis.reversed,//轴反正
          	 	categories: null,//x轴科目
   				lineWidth:1,//线宽
          	 	gridLineWidth:1,//网格线宽
          	 	type: _options.xAxis.type,
          	 	tickColor: _options.xAxis.tickColor,
          	 	tickWidth: _options.xAxis.tickWidth,
	          	labels:{
	            	enabled:true
	            }    
	        },
	        yAxis: {
	        	type: 'logarithmic',
	            showEmpty: false,
	            title: {
	                text: null
	            },
	            lineWidth:1,
	            gridLineWidth:1,
	            labels: {
	                enabled:true
	            }
	        },
	        tooltip: {
	     	    shared:_options.tooltip.shared,//数据描述是否一起显示
	     	    shadow:_options.tooltip.shadow,
	     	    crosshairs: _options.tooltip.crosshairs,
	     	    headerFormat: _options.tooltip.headerFormat,
    		    pointFormat: _options.tooltip.pointFormat
       		},
	        plotOptions: {
		        area: {
	                stacking: _options.plotOptions.area.stacking,//normal,percent
	                lineColor: '#666666',
	                lineWidth: 1,
	                marker: {
	                    lineWidth: 1,
	                    lineColor: '#666666'
	                }
	            },
	            series: {
	                dataLabels: {
	                    enabled: _options.series.dataLabels.enabled
	           //         format: '<b>{point.name}</b> ({point.y:,.0f})',
	           //        color: 'black',
	           //        softConnector: true
	                }
	           //    neckWidth: '30%',
	           //    neckHeight: '25%'
	             }
	          
      	    }
	        //设定报表对象的初始数据
	        //series: model.series.serieList
     });
    var type;
    /*
    if(optionsJson != undefined && optionsJson !=''){//options的json串
        type=optionsJson.chart.type; 
	    options.chart.type=type;//视图类型
		options.title.text=optionsJson.title.text;//标题
		options.subtitle.text=optionsJson.subtitle.text;//副标题
		options.yAxis.title.text=optionsJson.yAxis.title.text;//y轴标题
		options.series=optionsJson.series;//设定报表对象的初始数据
    }*/
    if(optionsJson != undefined && optionsJson !=''){//options的json串
    	var width="100%",height="100%";
    	if(optionsJson.divStyle != undefined && optionsJson.divStyle.width && optionsJson.divStyle.width != ''){
    		width = optionsJson.divStyle.width;
    	}
    	if(optionsJson.divStyle != undefined && optionsJson.divStyle.height && optionsJson.divStyle.height != ''){
    	    height = optionsJson.divStyle.height;
    	} 
    	$("#"+ optionsJson.renderTo).css("width",width).css("height",height);
        type=optionsJson.type; 
	    options.chart.type=type;//视图类型
	    if(options.title.text==null){
	    	options.title.text=optionsJson.title;//标题
	    }
		options.subtitle.text=optionsJson.subtitle;//副标题
		options.chart.renderTo=optionsJson.renderTo;
		options.chart.marginRight=optionsJson.marginRight;
		if(optionsJson.marginRight != undefined && optionsJson.marginRight != ''){
			options.chart.marginRight=optionsJson.marginRight;//距离右侧间距
		}
		if(optionsJson.yAxisTitle != undefined && optionsJson.yAxisTitle != ''){
			options.yAxis.title.text=optionsJson.yAxisTitle;//y轴标题
		}
		var dataMap = new Map();
		$.each(optionsJson.data,function(i,o){
			dataEntity = {name:o.categorie,y:o.data,sliced:o.sliced,selected:o.selected};
			var array = dataMap.get(o.name);
			if(array==null){
				array = new Array();
				array.push(dataEntity);
				dataMap.put(o.name,array);
			}else{
				array.push(dataEntity);
				dataMap.put(o.name,array);
			}
		});
		 var names = dataMap.keyValues();
		 var serie = new Array();
		 for (var i = 0; i < names.length; i++) {
		    var name = dataMap.keyValues()[i];
		    var datas = dataMap.get(name);
		    var values =  new Array();
		    for(var j=0;j<datas.length;j++){
		    	o = datas[j];
		    	values.push({name:o.name,y:o.y,sliced:o.sliced,selected:o.selected});
		    }
		   	serie.push({name:name,data:values});
		 }
		//alert(JSON.stringify(serie));
		options.series = serie;//设定报表对象的初始数据
    }else{//option的model对象
	    type=model.chart.type; 
	    options.chart.type=type;//视图类型
	    if(options.title.text==null){
	    	options.title.text=model.title.text;//标题
	    }
		options.subtitle.text=model.subtitle.text;//副标题
		options.yAxis.title.text=model.yaxis.title.text;//y轴标题
		options.series=model.series.serieList;//设定报表对象的初始数据
		if(model.tooltip.pointFormat && model.tooltip.pointFormat != ""){
			options.tooltip.pointFormat= model.tooltip.pointFormat;
		}
    }
	if(options.xAxis.type != 'datetime'){//x轴类型
	 if(optionsJson != undefined && optionsJson !=''){//options的json串
		options.xAxis.categories={categories: []};
    }else{//option的model对象
	  	options.xAxis.categories=model.xaxis.categories;
    }
	}else{
		options.tooltip = ({
			formatter: function () {  
                     return '<b>' + this.series.name + '</b><br/>' +  
                     Highcharts.dateFormat('%Y-%m-%d', this.x) + ': ' + this.y; 
                     } 
         });  
		options.xAxis.labels =({
			formatter:function () {  
	                      return Highcharts.dateFormat('%Y-%m-%d', this.value); 
	                  }
		});
	}
    //默认打开第一个
    if(type == 'line'){
    	
    }else if(type == 'area'){
    	
    }else if(type == 'pie'){
    
    }else if(type == 'gauge'){//仪表盘特有属性
	    options.pane=({
			        startAngle: -150,
			        endAngle: 150,
			        background: [{
			            backgroundColor: {
			                linearGradient: { x1: 0, y1: 0, x2: 0, y2: 1 },
			                stops: [
			                    [0, '#FFF'],
			                    [1, '#333']
			                ]
			            },
			            borderWidth: 0,
			            outerRadius: '109%'
			        }, {
			            backgroundColor: {
			                linearGradient: { x1: 0, y1: 0, x2: 0, y2: 1 },
			                stops: [
			                    [0, '#333'],
			                    [1, '#FFF']
			                ]
			            },
			            borderWidth: 1,
			            outerRadius: '107%'
			        }, {
			            // default background
			        }, {
			            backgroundColor: '#DDD',
			            borderWidth: 0,
			            outerRadius: '105%',
			            innerRadius: '103%'
			        }]
		});
		options.yAxis=({
		        min: model.yaxis.min,
		        max: model.yaxis.max,		        
		        minorTickInterval: 'auto',
		        minorTickWidth: 1,
		        minorTickLength: 10,
		        minorTickPosition: 'inside',
		        minorTickColor: '#666',
		
		        tickPixelInterval: 30,
		        tickWidth: 2,
		        tickPosition: 'inside',
		        tickLength: 10,
		        tickColor: '#666',
		        plotBands: model.yaxis.plotBands,
	            title: {
	                text: model.yaxis.title.text
	            },
	            labels: {
	                enabled:true,
	                step: 2,
		            rotation: 'auto'
	            }
		});
	
    }
    //设置背景色.模板使用时，无法引入metaTemp.jsp，修改THEMEURL判断
    if('undefined' ==typeof(THEMEURL) || undefined==THEMEURL ){
    	  color="default";
    	
    }else{
		switch(THEMEURL){
			case 'default':backgroundColor='#E8F4FD';break;
			case 'green':backgroundColor='#EAFBEA';break;
			case 'grey':backgroundColor='#F3F3F3';break;
			case 'red':backgroundColor='#FDF8E7';break;
			case 'purple':backgroundColor='#F2EDF9';break;
			case 'brown':backgroundColor='#F9F4ED';break;
	    	
	    }
	  
    }
    options.chart.backgroundColor=backgroundColor ;
	chart = new Highcharts.Chart(options);
	this.getHighcharts = function(){
		return chart;
	}
	this.getOptions = function(){
		return options;
	}
	this.destroy = function(){
			chart.destroy();
    }
    this.refresh = function(){
			$.ajax({
				   type: "POST",
				   url: url,
				   dataType:"json",
				   success: function(model){
				   		chart = new Jc6Highcharts(model);
				   },
				  	error:function(){
						alert("刷新失败");
				   }
			});
    }
    this.changeSkin = function(color){
		if(color==undefined)color="default";
		var showColor;
		switch(color){
			case 'default':showColor='#E8F4FD';break;
			case 'green':showColor='#EAFBEA';break;
			case 'grey':showColor='#F3F3F3';break;
			case 'red':showColor='#FDF8E7';break;
			case 'purple':showColor='#F2EDF9';break;
			case 'brown':showColor='#F9F4ED';break;
   		}
		return showColor;
	}
     return this;
    
}


